#include "c:\clip87\nandef.h"
#include "c:\clip87\extend.h"

static byte   t_fra[256] = {'\000','\001','\002','\003','\004','\005','\006','\007',
                            '\010','\011','\012','\013','\014','\015','\016','\017',
                            '\020','\021','\022','\023','\024','\025','\026','\027',
                            '\030','\031','\032','\033','\034','\035','\036','\037',
                            '\040','\041','\042','\043','\044','\045','\046','\047',
                            '\050','\051','\052','\053','\054','\055','\056','\057',
                            '\060','\061','\062','\063','\064','\065','\066','\067',
                            '\070','\071','\072','\073','\074','\075','\076','\040',
                            '\100','\101','\102','\103','\104','\105','\106','\107',
                            '\110','\111','\112','\113','\114','\115','\116','\117',
                            '\120','\121','\122','\123','\124','\125','\126','\127',
                            '\130','\131','\132','\133','\134','\135','\136','\137',
                            '\140','\101','\102','\103','\104','\105','\106','\107',
                            '\110','\111','\112','\113','\114','\115','\116','\117',
                            '\120','\121','\122','\123','\124','\125','\126','\127',
                            '\130','\131','\132','\173','\174','\175','\176','\177',
                            '\103','\125','\105','\101','\101','\101','\101','\103',
                            '\105','\105','\105','\111','\111','\111','\101','\101',
                            '\105','\221','\222','\117','\117','\117','\125','\125',
                            '\131','\117','\125','\233','\234','\235','\236','\237',
                            '\101','\111','\117','\125','\116','\116','\101','\117',
                            '\250','\251','\252','\253','\254','\255','\256','\257',
                            '\260','\261','\262','\263','\264','\265','\266','\267',
                            '\270','\271','\272','\273','\274','\275','\276','\277',
                            '\300','\301','\302','\303','\304','\305','\306','\307',
                            '\310','\311','\312','\313','\314','\315','\316','\317',
                            '\320','\321','\322','\323','\324','\325','\326','\327',
                            '\330','\331','\332','\333','\334','\335','\336','\337',
                            '\340','\341','\342','\343','\344','\345','\346','\347',
                            '\350','\351','\352','\353','\354','\355','\356','\357',
                            '\360','\361','\362','\363','\364','\365','\366','\367',
                            '\370','\371','\372','\373','\374','\375','\376','\377'};

static byte   t_tri[256],                             /* collating sequence */
              work[256];          /* this is the maximum the function takes */
                                       /* change the value if you want more */

static quant  res,                                     /* function's result */
              pos,                                            /* left value */
              val;                                           /* right value */

/***
*
*  Function: jl_sxlate()
*    Author: Jacques Lauz
*      Date: May-5-1989
*   Purpose: Translate a character string according to the table used.
*    Syntax: JL_SXLATE(<string to translate>)
*    Return: <translated string>
*
***/

CLIPPER JL_SXLATE()
{
  quant i,                                            /* temporary variable */
        l_in;                                 /* length of the input string */

  byte  *s_in,                                              /* input string */
        *s_out;                                            /* output string */

  for (s_in = _parc(1), l_in = (quant)(_parclen(1)), s_out = work, i = 0; i < l_in; i++)
    s_out[i] = t_tri[s_in[i]];

  _retclen(s_out,l_in);
}

/***
*
*  Function: jl_stable(<ASCII table/French>)
*    Author: Jacques Lauze
*      Date: January-14-1989
*   Purpose: Initialize the collating sequence
*   Syntaxe: JL_STABLE(<table code>)
*    Retour: 0 = No error
*            1 = Invalid table
*
***/

CLIPPER JL_STABLE()
{
  byte  mode,                               /* 0 = ASCII table   1 = French */
        *s_out,                                                    /* t_tri */
        *s_in;                                              /* french table */

  mode  = _parni(1);
  s_out = t_tri;                           /* pointer to collating sequence */
  res = 1;                                              /* default is error */

  if ( mode == 0 )
  {
    for ( res = 0 , pos = 0 ; pos < 256 ; pos++ )
      *s_out++ = pos;                        /* collating sequence is ASCII */
  }

  if ( mode == 1 )
  {
    for ( s_in = t_fra , res = 0 , pos = 0 ; pos < 256 ; pos++ )
      *s_out++ = *s_in++;                   /* collating sequence is french */
  }

  _retni(res);
}

/***
*
*  Function: jl_schar()
*    Author: Jacques Lauz
*      Date: May-5-1989
*   Purpose: Change a character in the collating sequence
*    Syntax: JL_SCHAR(position in the collating sequence,new value)
*    Return: 0 = O.K.
*            1 = Invalid position
*            2 = Invalid value
*
***/

CLIPPER JL_SCHAR()
{
  byte  *s_pos,                       /* position in the collating sequence */
        *s_val;                                      /* new collating value */

  s_pos = _parc(1);
  s_val = _parc(2);
  res = 0;                                           /* default is no error */

  if ( (*s_pos < 0) || (*s_pos > 255) )
    res = 1;
  else
  {
    if ( (*s_val < 0) || (*s_val > 255) )
      res = 2;
    else
      t_tri[*s_pos] = (byte)*s_val;                 /* record the new value */
  }

  _retni(res);
}